#	Masrv
#	Copyright (C) 2007 Michal Vaner (vorner@ucw.cz)
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	he Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import selector

class manager:
	def __init__( self, modeler ):
		self.__modeler = modeler
		self.__clients = []
		selector.insertPeriodic( self )

	def tick( self, timestamp ):
		toUpdate = []
		mod = self.__modeler.update( timestamp )
		self.__modeler.changed = False
		for c in self.__clients:
			if c.wantUpdate( timestamp, mod ):
				toUpdate.append( c )
		if toUpdate:
			state = self.__modeler.getState()
		for c in toUpdate:
			c.pushUpdate( state, timestamp )

	def insert( self, client ):
		self.__clients.append( client )

	def remove( self, client ):
		try:
			self.__clients.remove( client )
		except:
			pass
