#!/usr/bin/env python

#	Masrv
#	Copyright (C) 2007 Michal Vaner (vorner@ucw.cz)
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	he Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import glob
import config
import sys
import re
import source
import os
import selector
import listener
import images
import manager

cmdArgs = sys.argv[ 1: ]

if "-h" in cmdArgs or "--help" in cmdArgs:
	print "Usage:"
	print "masrv --help | [--debug] --config=<config>"
	print "--help|-h\t\tThis help message."
	print "--debug|-d\t\tEnable debug output."
	print "--daemon|-D\t\tBecome a daemon."
	print "--config=<config>\tUse this config file. Must be present."
	sys.exit()

if "-d" in cmdArgs or "--debug" in cmdArgs:
	glob.debug = True
confRe = re.compile( "^--config=(.*)$" )
for arg in cmdArgs:
	mo = confRe.match( arg )
	if ( mo ):
		config.load( mo.group( 1 ) )
		break

if not config.loaded:
	glob.fatal( "No config loaded" )

imgcache = images.images()

src = source.source( imgcache )
selector.insert( src )#get the pipe that will keep us informed what happens

manager = manager.manager( src.modeler() )

if "-D" in cmdArgs or "--daemon" in cmdArgs:
	if glob.debug:
		glob.warn( "Can not become daemon in debug mode" )
	else:
		os.close( sys.stdin.fileno() )#Close the inputs/outputs
		os.close( sys.stdout.fileno() )
		os.close( sys.stderr.fileno() )

		if os.fork():#The parent will terminate
			sys.exit()
		glob.daemon = True

selector.insert( listener.listener( imgcache, manager ) )#listen for incomming connections

selector.run()
